require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_ARM_BITOPS_H)) {
    eval 'sub __ASM_ARM_BITOPS_H () {1;}' unless defined(&__ASM_ARM_BITOPS_H);
    if(defined(&__KERNEL__)) {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub __set_bit {
	    local($nr,$addr) = @_;
    	    eval q({ ( $addr)[$nr >> 3] |= (1 << ($nr & 7)); });
	}' unless defined(&__set_bit);
	eval 'sub __clear_bit {
	    local($nr,$addr) = @_;
    	    eval q({ ( $addr)[$nr >> 3] &= ~(1 << ($nr & 7)); });
	}' unless defined(&__clear_bit);
	eval 'sub __change_bit {
	    local($nr,$addr) = @_;
    	    eval q({ ( $addr)[$nr >> 3] ^= (1 << ($nr & 7)); });
	}' unless defined(&__change_bit);
	eval 'sub __test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q({ my $mask = 1<< ($nr & 7); my $oldval;  $oldval = [$nr >> 3]; ( $addr)[$nr >> 3] =  $oldval |  $mask;  $oldval &  $mask; });
	}' unless defined(&__test_and_set_bit);
	eval 'sub __test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q({ my $mask = 1<< ($nr & 7); my $oldval;  $oldval = [$nr >> 3]; ( $addr)[$nr >> 3] =  $oldval & ~ $mask;  $oldval &  $mask; });
	}' unless defined(&__test_and_clear_bit);
	eval 'sub __test_and_change_bit {
	    local($nr,$addr) = @_;
    	    eval q({ my $mask = 1<< ($nr & 7); my $oldval;  $oldval = [$nr >> 3]; ( $addr)[$nr >> 3] =  $oldval ^  $mask;  $oldval &  $mask; });
	}' unless defined(&__test_and_change_bit);
	eval 'sub ffs {
	    local($x) = @_;
    	    eval q( &generic_ffs($x));
	}' unless defined(&ffs);
	eval 'sub hweight32 {
	    local($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    local($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    local($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	eval 'sub ext2_set_bit () { &test_and_set_bit;}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit () { &test_and_clear_bit;}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_test_bit () { &test_bit;}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit () { &find_first_zero_bit;}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit () { &find_next_zero_bit;}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
