require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASMARM_UACCESS_H)) {
    eval 'sub _ASMARM_UACCESS_H () {1;}' unless defined(&_ASMARM_UACCESS_H);
    require 'linux/sched.ph';
    require 'asm/errno.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( ($current->{addr_limit})));
    }' unless defined(&get_fs);
    eval 'sub segment_eq {
        local($a,$b) = @_;
	    eval q((($a) == ($b)));
    }' unless defined(&segment_eq);
    require 'asm/proc/uaccess.ph';
    eval 'sub access_ok {
        local($type,$addr,$size) = @_;
	    eval q(( &__range_ok($addr,$size) == 0));
    }' unless defined(&access_ok);
    eval 'sub verify_area {
        local($type,$addr,$size) = @_;
	    eval q({  &access_ok($type, $addr, $size) ? 0: - &EFAULT; });
    }' unless defined(&verify_area);
    eval 'sub __get_user_x () {( &__r1, &__p, &__e, &__s, &__i...)  &__asm__  &__volatile__ ("bl	__get_user_"  &__s : "=&r" ( &__e), "=r" ( &__r1) : "0" ( &__p) :  &__i);}' unless defined(&__get_user_x);
    eval 'sub get_user {
        local($x,$p) = @_;
	    eval q(({  &const  &register  &typeof(*($p)) * &__p  &asm(\\"r0\\") = ($p);  &register  &typeof(*($p))  &__r1  &asm(\\"r1\\");  &register \'int\'  &__e  &asm(\\"r0\\");  &switch ($sizeof{($p)}) {  &case 1:  &__get_user_x( &__r1,  &__p,  &__e, 1, \\"lr\\");  &break;  &case 2:  &__get_user_x( &__r1,  &__p,  &__e, 2, \\"r2\\", \\"lr\\");  &break;  &case 4:  &__get_user_x( &__r1,  &__p,  &__e, 4, \\"lr\\");  &break;  &case 8:  &__get_user_x( &__r1,  &__p,  &__e, 8, \\"lr\\");  &break;  &default:  &__e =  &__get_user_bad();  &break; } $x =  &__r1;  &__e; }));
    }' unless defined(&get_user);
    eval 'sub __get_user {
        local($x,$p) = @_;
	    eval q( &__get_user_nocheck(($x),($p),$sizeof{($p)}));
    }' unless defined(&__get_user);
    eval 'sub __get_user_error {
        local($x,$p,$e) = @_;
	    eval q( &__get_user_nocheck_error(($x),($p),$sizeof{($p)},($e)));
    }' unless defined(&__get_user_error);
    eval 'sub __put_user_x () {( &__r1, &__p, &__e, &__s, &__i...)  &__asm__  &__volatile__ ("bl	__put_user_"  &__s : "=&r" ( &__e) : "0" ( &__p), "r" ( &__r1) :  &__i);}' unless defined(&__put_user_x);
    eval 'sub put_user {
        local($x,$p) = @_;
	    eval q(({  &const  &register  &typeof(*($p))  &__r1  &asm(\\"r1\\") = ($x);  &const  &register  &typeof(*($p)) * &__p  &asm(\\"r0\\") = ($p);  &register \'int\'  &__e  &asm(\\"r0\\");  &switch ($sizeof{($p)}) {  &case 1:  &__put_user_x( &__r1,  &__p,  &__e, 1, \\"r2\\", \\"lr\\");  &break;  &case 2:  &__put_user_x( &__r1,  &__p,  &__e, 2, \\"r2\\", \\"lr\\");  &break;  &case 4:  &__put_user_x( &__r1,  &__p,  &__e, 4, \\"r2\\", \\"lr\\");  &break;  &case 8:  &__put_user_x( &__r1,  &__p,  &__e, 8, \\"ip\\", \\"lr\\");  &break;  &default:  &__e =  &__put_user_bad();  &break; }  &__e; }));
    }' unless defined(&put_user);
    eval 'sub __put_user {
        local($x,$p) = @_;
	    eval q( &__put_user_nocheck(( &__typeof(*($p)))($x),($p),$sizeof{($p)}));
    }' unless defined(&__put_user);
    eval 'sub __put_user_error {
        local($x,$p,$e) = @_;
	    eval q( &__put_user_nocheck_error(($x),($p),$sizeof{($p)},($e)));
    }' unless defined(&__put_user_error);
    eval 'sub copy_from_user {
        local($to,$from,$n) = @_;
	    eval q({  &if ( &access_ok( &VERIFY_READ, $from, $n))  &__do_copy_from_user($to, $from, $n);  &else  &memzero($to, $n); $n; });
    }' unless defined(&copy_from_user);
    eval 'sub __copy_from_user {
        local($to,$from,$n) = @_;
	    eval q({  &__do_copy_from_user($to, $from, $n); $n; });
    }' unless defined(&__copy_from_user);
    eval 'sub copy_to_user {
        local($to,$from,$n) = @_;
	    eval q({  &if ( &access_ok( &VERIFY_WRITE, $to, $n))  &__do_copy_to_user($to, $from, $n); $n; });
    }' unless defined(&copy_to_user);
    eval 'sub __copy_to_user {
        local($to,$from,$n) = @_;
	    eval q({  &__do_copy_to_user($to, $from, $n); $n; });
    }' unless defined(&__copy_to_user);
    eval 'sub clear_user {
        local($to,$n) = @_;
	    eval q({  &if ( &access_ok( &VERIFY_WRITE, $to, $n))  &__do_clear_user($to, $n); $n; });
    }' unless defined(&clear_user);
    eval 'sub __clear_user {
        local($to,$n) = @_;
	    eval q({  &__do_clear_user($to, $n); $n; });
    }' unless defined(&__clear_user);
    eval 'sub strncpy_from_user {
        local($dst,$src,$count) = @_;
	    eval q({ my $res = - &EFAULT;  &if ( &access_ok( &VERIFY_READ, $src, 1))  &__do_strncpy_from_user($dst, $src, $count,  $res);  $res; });
    }' unless defined(&strncpy_from_user);
    eval 'sub __strncpy_from_user {
        local($dst,$src,$count) = @_;
	    eval q({ my $res;  &__do_strncpy_from_user($dst, $src, $count,  $res);  $res; });
    }' unless defined(&__strncpy_from_user);
    eval 'sub strlen_user {
        local($s) = @_;
	    eval q( &strnlen_user($s, ~0 >> 1));
    }' unless defined(&strlen_user);
    eval 'sub strnlen_user {
        local($s,$n) = @_;
	    eval q({ my $res = 0;  &if ( &__addr_ok($s))  &__do_strnlen_user($s, $n,  $res);  $res; });
    }' unless defined(&strnlen_user);
    if(0) {
	eval 'sub __get_user_check {
	    local($x,$ptr,$size) = @_;
    	    eval q(({ \'long __gu_err\' = - &EFAULT,  &__gu_val = 0;  &const  &__typeof__(*($ptr)) * &__gu_addr = ($ptr);  &if ( &access_ok( &VERIFY_READ, &__gu_addr,$size)) {  &__gu_err = 0;  &__get_user_size( &__gu_val, &__gu_addr,($size), &__gu_err); } ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
	}' unless defined(&__get_user_check);
    }
    eval 'sub __get_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\' = 0,  &__gu_val;  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_nocheck_error {
        local($x,$ptr,$size,$err) = @_;
	    eval q(({ \'long __gu_val\';  &__get_user_size( &__gu_val,($ptr),($size),($err)); ($x) = ( &__typeof__(*($ptr))) &__gu_val; ( &void) 0; }));
    }' unless defined(&__get_user_nocheck_error);
    eval 'sub __put_user_check {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\' = - &EFAULT;  &__typeof__(*($ptr)) * &__pu_addr = ($ptr);  &if ( &access_ok( &VERIFY_WRITE, &__pu_addr,$size)) {  &__pu_err = 0;  &__put_user_size(($x), &__pu_addr,($size), &__pu_err); }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\' = 0;  &__typeof__(*($ptr)) * &__pu_addr = ($ptr);  &__put_user_size(($x), &__pu_addr,($size), &__pu_err);  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_nocheck_error {
        local($x,$ptr,$size,$err) = @_;
	    eval q(({  &__put_user_size(($x),($ptr),($size),$err); ( &void) 0; }));
    }' unless defined(&__put_user_nocheck_error);
    eval 'sub __get_user_size {
        local($x,$ptr,$size,$retval) = @_;
	    eval q( &do {  &switch ($size) {  &case 1:  &__get_user_asm_byte($x,$ptr,$retval);  &break;  &case 2:  &__get_user_asm_half($x,$ptr,$retval);  &break;  &case 4:  &__get_user_asm_word($x,$ptr,$retval);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user_size);
    eval 'sub __put_user_size {
        local($x,$ptr,$size,$retval) = @_;
	    eval q( &do {  &switch ($size) {  &case 1:  &__put_user_asm_byte($x,$ptr,$retval);  &break;  &case 2:  &__put_user_asm_half($x,$ptr,$retval);  &break;  &case 4:  &__put_user_asm_word($x,$ptr,$retval);  &break;  &default:  &__put_user_bad(); } }  &while (0));
    }' unless defined(&__put_user_size);
}
1;
