require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MATH_H)) {
    die("Never use <bits/huge_val.h> directly; include <math.h> instead.");
}
require 'features.ph';
if(defined(&__GNUC__)) {
    if( &__GNUC_PREREQ(2,96)) {
	eval 'sub HUGE_VAL () {( &__extension__ 0x1.0 &p2047);}' unless defined(&HUGE_VAL);
    } else {
	eval 'sub HUGE_VAL () {( &__extension__ ((\'union union\' {  &unsigned __l __attribute__(( &__mode__( &__DI__))); \'double\'  &__d; }) {  &__l: 0x7ff00000 }). &__d);}' unless defined(&HUGE_VAL);
    }
} else {
    require 'endian.ph';
    if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : 0)) {
	eval 'sub __HUGE_VAL_bytes () {{ 0, 0, 0, 0, 0x7f, 0xf0, 0, 0};}' unless defined(&__HUGE_VAL_bytes);
    }
    if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__LITTLE_ENDIAN) ? &__LITTLE_ENDIAN : 0)) {
	eval 'sub __HUGE_VAL_bytes () {{ 0, 0, 0xf0, 0x7f, 0, 0, 0, 0};}' unless defined(&__HUGE_VAL_bytes);
    }
    eval 'sub HUGE_VAL () {( ($__huge_val->{__d}));}' unless defined(&HUGE_VAL);
}
if(defined(&__USE_ISOC99)) {
    if(defined(&__GNUC__)) {
	if( &__GNUC_PREREQ(2,96)) {
	    eval 'sub HUGE_VALF () {( &__extension__ 0x1.0 &p255f);}' unless defined(&HUGE_VALF);
	} else {
	    eval 'sub HUGE_VALF () {( &__extension__ ((\'union union\' {  &unsigned __l __attribute__(( &__mode__( &__SI__))); \'float\'  &__d; }) {  &__l: 0x7f800000 }). &__d);}' unless defined(&HUGE_VALF);
	}
    } else {
	if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__BIG_ENDIAN) ? &__BIG_ENDIAN : 0)) {
	    eval 'sub __HUGE_VALF_bytes () {{ 0x7f, 0x80, 0, 0};}' unless defined(&__HUGE_VALF_bytes);
	}
	if((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : 0) == (defined(&__LITTLE_ENDIAN) ? &__LITTLE_ENDIAN : 0)) {
	    eval 'sub __HUGE_VALF_bytes () {{ 0, 0, 0x80, 0x7f };}' unless defined(&__HUGE_VALF_bytes);
	}
	eval 'sub HUGE_VALF () {( ($__huge_valf->{__f}));}' unless defined(&HUGE_VALF);
    }
    eval 'sub HUGE_VALL () { &HUGE_VAL;}' unless defined(&HUGE_VALL);
}
1;
