require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_NETINET_IN_H)) {
    die("Never use <bits/in.h> directly; include <netinet/in.h> instead.");
}
unless(defined(&IP_TOS)) {
    sub IP_TOS () {	1;}
}
unless(defined(&IP_TTL)) {
    sub IP_TTL () {	2;}
}
unless(defined(&IP_HDRINCL)) {
    sub IP_HDRINCL () {	3;}
}
unless(defined(&IP_OPTIONS)) {
    sub IP_OPTIONS () {	4;}
}
unless(defined(&IP_ROUTER_ALERT)) {
    sub IP_ROUTER_ALERT () {	5;}
}
unless(defined(&IP_RECVOPTS)) {
    sub IP_RECVOPTS () {	6;}
}
unless(defined(&IP_RETOPTS)) {
    sub IP_RETOPTS () {	7;}
}
unless(defined(&IP_PKTINFO)) {
    sub IP_PKTINFO () {	8;}
}
unless(defined(&IP_PKTOPTIONS)) {
    sub IP_PKTOPTIONS () {	9;}
}
unless(defined(&IP_PMTUDISC)) {
    sub IP_PMTUDISC () {	10;}
}
unless(defined(&IP_MTU_DISCOVER)) {
    sub IP_MTU_DISCOVER () {	10;}
}
unless(defined(&IP_RECVERR)) {
    sub IP_RECVERR () {	11;}
}
unless(defined(&IP_RECVTTL)) {
    sub IP_RECVTTL () {	12;}
}
unless(defined(&IP_RECVTOS)) {
    sub IP_RECVTOS () {	13;}
}
unless(defined(&IP_MULTICAST_IF)) {
    sub IP_MULTICAST_IF () {	32;}
}
unless(defined(&IP_MULTICAST_TTL)) {
    sub IP_MULTICAST_TTL () {	33;}
}
unless(defined(&IP_MULTICAST_LOOP)) {
    sub IP_MULTICAST_LOOP () {	34;}
}
unless(defined(&IP_ADD_MEMBERSHIP)) {
    sub IP_ADD_MEMBERSHIP () {	35;}
}
unless(defined(&IP_DROP_MEMBERSHIP)) {
    sub IP_DROP_MEMBERSHIP () {	36;}
}
unless(defined(&IP_RECVRETOPTS)) {
    sub IP_RECVRETOPTS () {	 &IP_RETOPTS;}
}
unless(defined(&IP_PMTUDISC_DONT)) {
    sub IP_PMTUDISC_DONT () {	0;}
}
unless(defined(&IP_PMTUDISC_WANT)) {
    sub IP_PMTUDISC_WANT () {	1;}
}
unless(defined(&IP_PMTUDISC_DO)) {
    sub IP_PMTUDISC_DO () {	2;}
}
unless(defined(&SOL_IP)) {
    sub SOL_IP () {	0;}
}
unless(defined(&IP_DEFAULT_MULTICAST_TTL)) {
    sub IP_DEFAULT_MULTICAST_TTL () {	1;}
}
unless(defined(&IP_DEFAULT_MULTICAST_LOOP)) {
    sub IP_DEFAULT_MULTICAST_LOOP () {	1;}
}
unless(defined(&IP_MAX_MEMBERSHIPS)) {
    sub IP_MAX_MEMBERSHIPS () {	20;}
}
unless(defined(&IPV6_ADDRFORM)) {
    sub IPV6_ADDRFORM () {	1;}
}
unless(defined(&IPV6_PKTINFO)) {
    sub IPV6_PKTINFO () {	2;}
}
unless(defined(&IPV6_HOPOPTS)) {
    sub IPV6_HOPOPTS () {	3;}
}
unless(defined(&IPV6_DSTOPTS)) {
    sub IPV6_DSTOPTS () {	4;}
}
unless(defined(&IPV6_RTHDR)) {
    sub IPV6_RTHDR () {	5;}
}
unless(defined(&IPV6_PKTOPTIONS)) {
    sub IPV6_PKTOPTIONS () {	6;}
}
unless(defined(&IPV6_CHECKSUM)) {
    sub IPV6_CHECKSUM () {	7;}
}
unless(defined(&IPV6_HOPLIMIT)) {
    sub IPV6_HOPLIMIT () {	8;}
}
unless(defined(&IPV6_NEXTHOP)) {
    sub IPV6_NEXTHOP () {	9;}
}
unless(defined(&IPV6_AUTHHDR)) {
    sub IPV6_AUTHHDR () {	10;}
}
unless(defined(&IPV6_UNICAST_HOPS)) {
    sub IPV6_UNICAST_HOPS () {	16;}
}
unless(defined(&IPV6_MULTICAST_IF)) {
    sub IPV6_MULTICAST_IF () {	17;}
}
unless(defined(&IPV6_MULTICAST_HOPS)) {
    sub IPV6_MULTICAST_HOPS () {	18;}
}
unless(defined(&IPV6_MULTICAST_LOOP)) {
    sub IPV6_MULTICAST_LOOP () {	19;}
}
unless(defined(&IPV6_JOIN_GROUP)) {
    sub IPV6_JOIN_GROUP () {	20;}
}
unless(defined(&IPV6_LEAVE_GROUP)) {
    sub IPV6_LEAVE_GROUP () {	21;}
}
unless(defined(&IPV6_ROUTER_ALERT)) {
    sub IPV6_ROUTER_ALERT () {	22;}
}
unless(defined(&IPV6_MTU_DISCOVER)) {
    sub IPV6_MTU_DISCOVER () {	23;}
}
unless(defined(&IPV6_MTU)) {
    sub IPV6_MTU () {	24;}
}
unless(defined(&IPV6_RECVERR)) {
    sub IPV6_RECVERR () {	25;}
}
unless(defined(&SCM_SRCRT)) {
    sub SCM_SRCRT () {	 &IPV6_RXSRCRT;}
}
unless(defined(&IPV6_RXHOPOPTS)) {
    sub IPV6_RXHOPOPTS () {	 &IPV6_HOPOPTS;}
}
unless(defined(&IPV6_RXDSTOPTS)) {
    sub IPV6_RXDSTOPTS () {	 &IPV6_DSTOPTS;}
}
unless(defined(&IPV6_ADD_MEMBERSHIP)) {
    sub IPV6_ADD_MEMBERSHIP () {	 &IPV6_JOIN_GROUP;}
}
unless(defined(&IPV6_DROP_MEMBERSHIP)) {
    sub IPV6_DROP_MEMBERSHIP () {	 &IPV6_LEAVE_GROUP;}
}
unless(defined(&IPV6_PMTUDISC_DONT)) {
    sub IPV6_PMTUDISC_DONT () {	0;}
}
unless(defined(&IPV6_PMTUDISC_WANT)) {
    sub IPV6_PMTUDISC_WANT () {	1;}
}
unless(defined(&IPV6_PMTUDISC_DO)) {
    sub IPV6_PMTUDISC_DO () {	2;}
}
unless(defined(&SOL_IPV6)) {
    sub SOL_IPV6 () {	41;}
}
unless(defined(&SOL_ICMPV6)) {
    sub SOL_ICMPV6 () {	58;}
}
unless(defined(&IPV6_RTHDR_LOOSE)) {
    sub IPV6_RTHDR_LOOSE () {	0;}
}
unless(defined(&IPV6_RTHDR_STRICT)) {
    sub IPV6_RTHDR_STRICT () {	1;}
}
unless(defined(&IPV6_RTHDR_TYPE_0)) {
    sub IPV6_RTHDR_TYPE_0 () {	0;}
}
1;
