require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_UCLIBC_FPMAX_H)) {
    eval 'sub _UCLIBC_FPMAX_H () {1;}' unless defined(&_UCLIBC_FPMAX_H);
    unless(defined(&_ISOC99_SOURCE)) {
	eval 'sub _ISOC99_SOURCE () {1;}' unless defined(&_ISOC99_SOURCE);
    }
    require 'features.ph';
    require 'float.ph';
    if(defined(&__UCLIBC_HAS_FLOATS__)) {
	if(defined( &LDBL_MANT_DIG)) {
	    eval 'sub FPMAX_TYPE () {3;}' unless defined(&FPMAX_TYPE);
	    eval 'sub FPMAX_MANT_DIG () { &LDBL_MANT_DIG;}' unless defined(&FPMAX_MANT_DIG);
	    eval 'sub FPMAX_DIG () { &LDBL_DIG;}' unless defined(&FPMAX_DIG);
	    eval 'sub FPMAX_EPSILON () { &LDBL_EPSILON;}' unless defined(&FPMAX_EPSILON);
	    eval 'sub FPMAX_MIN_EXP () { &LDBL_MIN_EXP;}' unless defined(&FPMAX_MIN_EXP);
	    eval 'sub FPMAX_MIN () { &LDBL_MIN;}' unless defined(&FPMAX_MIN);
	    eval 'sub FPMAX_MIN_10_EXP () { &LDBL_MIN_10_EXP;}' unless defined(&FPMAX_MIN_10_EXP);
	    eval 'sub FPMAX_MAX_EXP () { &LDBL_MAX_EXP;}' unless defined(&FPMAX_MAX_EXP);
	    eval 'sub FPMAX_MAX () { &LDBL_MAX;}' unless defined(&FPMAX_MAX);
	    eval 'sub FPMAX_MAX_10_EXP () { &LDBL_MAX_10_EXP;}' unless defined(&FPMAX_MAX_10_EXP);
	}
 elsif(defined( &DBL_MANT_DIG)) {
	    eval 'sub FPMAX_TYPE () {2;}' unless defined(&FPMAX_TYPE);
	    eval 'sub FPMAX_MANT_DIG () { &DBL_MANT_DIG;}' unless defined(&FPMAX_MANT_DIG);
	    eval 'sub FPMAX_DIG () { &DBL_DIG;}' unless defined(&FPMAX_DIG);
	    eval 'sub FPMAX_EPSILON () { &DBL_EPSILON;}' unless defined(&FPMAX_EPSILON);
	    eval 'sub FPMAX_MIN_EXP () { &DBL_MIN_EXP;}' unless defined(&FPMAX_MIN_EXP);
	    eval 'sub FPMAX_MIN () { &DBL_MIN;}' unless defined(&FPMAX_MIN);
	    eval 'sub FPMAX_MIN_10_EXP () { &DBL_MIN_10_EXP;}' unless defined(&FPMAX_MIN_10_EXP);
	    eval 'sub FPMAX_MAX_EXP () { &DBL_MAX_EXP;}' unless defined(&FPMAX_MAX_EXP);
	    eval 'sub FPMAX_MAX () { &DBL_MAX;}' unless defined(&FPMAX_MAX);
	    eval 'sub FPMAX_MAX_10_EXP () { &DBL_MAX_10_EXP;}' unless defined(&FPMAX_MAX_10_EXP);
	}
 elsif(defined( &FLT_MANT_DIG)) {
	    eval 'sub FPMAX_TYPE () {1;}' unless defined(&FPMAX_TYPE);
	    eval 'sub FPMAX_MANT_DIG () { &FLT_MANT_DIG;}' unless defined(&FPMAX_MANT_DIG);
	    eval 'sub FPMAX_DIG () { &FLT_DIG;}' unless defined(&FPMAX_DIG);
	    eval 'sub FPMAX_EPSILON () { &FLT_EPSILON;}' unless defined(&FPMAX_EPSILON);
	    eval 'sub FPMAX_MIN_EXP () { &FLT_MIN_EXP;}' unless defined(&FPMAX_MIN_EXP);
	    eval 'sub FPMAX_MIN () { &FLT_MIN;}' unless defined(&FPMAX_MIN);
	    eval 'sub FPMAX_MIN_10_EXP () { &FLT_MIN_10_EXP;}' unless defined(&FPMAX_MIN_10_EXP);
	    eval 'sub FPMAX_MAX_EXP () { &FLT_MAX_EXP;}' unless defined(&FPMAX_MAX_EXP);
	    eval 'sub FPMAX_MAX () { &FLT_MAX;}' unless defined(&FPMAX_MAX);
	    eval 'sub FPMAX_MAX_10_EXP () { &FLT_MAX_10_EXP;}' unless defined(&FPMAX_MAX_10_EXP);
	} else {
	    die("unable\ to\ determine\ appropriate\ type\ for\ __fpmax_t\!");
	}
	unless(defined(&DECIMAL_DIG)) {
	    if(defined(&L___strtofpmax)) {
		warn("DECIMAL_DIG\ is\ not\ defined\!\ If\ you\ are\ using\ gcc\,\ it\ may\ not\ be\ defining\ __STDC_VERSION__\ as\ it\ should\.");
	    }
	    if(!defined( &FLT_RADIX) || ((defined(&FLT_RADIX) ? &FLT_RADIX : 0) != 2)) {
		die("unable\ to\ compensate\ for\ missing\ DECIMAL_DIG\!");
	    }
	    eval 'sub DECIMAL_DIG () {(1+ ((( &FPMAX_MANT_DIG * 100) + 331) / 332));}' unless defined(&DECIMAL_DIG);
	}
	if(defined(&__UCLIBC_HAS_XLOCALE__)) {
	}
	if(defined(&__UCLIBC_HAS_WCHAR__)) {
	    if(defined(&__UCLIBC_HAS_XLOCALE__)) {
	    }
	}
	eval 'sub __FPMAX_ZERO_OR_INF_CHECK {
	    local($x) = @_;
    	    eval q((($x) == (($x)/4) ));
	}' unless defined(&__FPMAX_ZERO_OR_INF_CHECK);
    }
}
1;
