require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&COBALT_NVRAM_H)) {
    eval 'sub COBALT_NVRAM_H () {1;}' unless defined(&COBALT_NVRAM_H);
    require 'linux/nvram.ph';
    eval 'sub COBT_CMOS_INFO_MAX () {0x7f;}' unless defined(&COBT_CMOS_INFO_MAX);
    eval 'sub COBT_CMOS_BIOS_DRIVE_INFO () {0x12;}' unless defined(&COBT_CMOS_BIOS_DRIVE_INFO);
    eval 'sub COBT_CMOS_CKS_START () { &NVRAM_OFFSET(0xe);}' unless defined(&COBT_CMOS_CKS_START);
    eval 'sub COBT_CMOS_CKS_END () { &NVRAM_OFFSET(0x7f);}' unless defined(&COBT_CMOS_CKS_END);
    eval 'sub COBT_CMOS_FLAG_BYTE_0 () { &NVRAM_OFFSET(0x10);}' unless defined(&COBT_CMOS_FLAG_BYTE_0);
    eval 'sub COBT_CMOS_FLAG_BYTE_1 () { &NVRAM_OFFSET(0x11);}' unless defined(&COBT_CMOS_FLAG_BYTE_1);
    eval 'sub COBT_CMOS_FLAG_MIN () {0x1;}' unless defined(&COBT_CMOS_FLAG_MIN);
    eval 'sub COBT_CMOS_CONSOLE_FLAG () {0x1;}' unless defined(&COBT_CMOS_CONSOLE_FLAG);
    eval 'sub COBT_CMOS_DEBUG_FLAG () {0x2;}' unless defined(&COBT_CMOS_DEBUG_FLAG);
    eval 'sub COBT_CMOS_AUTO_PROMPT_FLAG () {0x4;}' unless defined(&COBT_CMOS_AUTO_PROMPT_FLAG);
    eval 'sub COBT_CMOS_CLEAN_BOOT_FLAG () {0x8;}' unless defined(&COBT_CMOS_CLEAN_BOOT_FLAG);
    eval 'sub COBT_CMOS_HW_NOPROBE_FLAG () {0x10;}' unless defined(&COBT_CMOS_HW_NOPROBE_FLAG);
    eval 'sub COBT_CMOS_SYSFAULT_FLAG () {0x20;}' unless defined(&COBT_CMOS_SYSFAULT_FLAG);
    eval 'sub COBT_CMOS_OOPSPANIC_FLAG () {0x40;}' unless defined(&COBT_CMOS_OOPSPANIC_FLAG);
    eval 'sub COBT_CMOS_DELAY_CACHE_FLAG () {0x80;}' unless defined(&COBT_CMOS_DELAY_CACHE_FLAG);
    eval 'sub COBT_CMOS_NOLOGO_FLAG () {0x100;}' unless defined(&COBT_CMOS_NOLOGO_FLAG);
    eval 'sub COBT_CMOS_VERSION_FLAG () {0x200;}' unless defined(&COBT_CMOS_VERSION_FLAG);
    eval 'sub COBT_CMOS_FLAG_MAX () {0x200;}' unless defined(&COBT_CMOS_FLAG_MAX);
    eval 'sub COBT_CMOS_VERSION () { &NVRAM_OFFSET(0x13);}' unless defined(&COBT_CMOS_VERSION);
    eval 'sub COBT_CMOS_VER_BTOCODE () {1;}' unless defined(&COBT_CMOS_VER_BTOCODE);
    eval 'sub COBT_CMOS_BOOT_METHOD () { &NVRAM_OFFSET(0x20);}' unless defined(&COBT_CMOS_BOOT_METHOD);
    eval 'sub COBT_CMOS_BOOT_METHOD_DISK () {0;}' unless defined(&COBT_CMOS_BOOT_METHOD_DISK);
    eval 'sub COBT_CMOS_BOOT_METHOD_ROM () {1;}' unless defined(&COBT_CMOS_BOOT_METHOD_ROM);
    eval 'sub COBT_CMOS_BOOT_METHOD_NET () {2;}' unless defined(&COBT_CMOS_BOOT_METHOD_NET);
    eval 'sub COBT_CMOS_BOOT_DEV_MIN () { &NVRAM_OFFSET(0x21);}' unless defined(&COBT_CMOS_BOOT_DEV_MIN);
    eval 'sub COBT_CMOS_BOOT_DEV0_MAJ () { &NVRAM_OFFSET(0x21);}' unless defined(&COBT_CMOS_BOOT_DEV0_MAJ);
    eval 'sub COBT_CMOS_BOOT_DEV0_MIN () { &NVRAM_OFFSET(0x22);}' unless defined(&COBT_CMOS_BOOT_DEV0_MIN);
    eval 'sub COBT_CMOS_BOOT_DEV1_MAJ () { &NVRAM_OFFSET(0x23);}' unless defined(&COBT_CMOS_BOOT_DEV1_MAJ);
    eval 'sub COBT_CMOS_BOOT_DEV1_MIN () { &NVRAM_OFFSET(0x24);}' unless defined(&COBT_CMOS_BOOT_DEV1_MIN);
    eval 'sub COBT_CMOS_BOOT_DEV2_MAJ () { &NVRAM_OFFSET(0x25);}' unless defined(&COBT_CMOS_BOOT_DEV2_MAJ);
    eval 'sub COBT_CMOS_BOOT_DEV2_MIN () { &NVRAM_OFFSET(0x26);}' unless defined(&COBT_CMOS_BOOT_DEV2_MIN);
    eval 'sub COBT_CMOS_BOOT_DEV3_MAJ () { &NVRAM_OFFSET(0x27);}' unless defined(&COBT_CMOS_BOOT_DEV3_MAJ);
    eval 'sub COBT_CMOS_BOOT_DEV3_MIN () { &NVRAM_OFFSET(0x28);}' unless defined(&COBT_CMOS_BOOT_DEV3_MIN);
    eval 'sub COBT_CMOS_BOOT_DEV_MAX () { &NVRAM_OFFSET(0x28);}' unless defined(&COBT_CMOS_BOOT_DEV_MAX);
    eval 'sub COBT_CMOS_CHECKSUM () { &NVRAM_OFFSET(0x2e);}' unless defined(&COBT_CMOS_CHECKSUM);
    eval 'sub COBT_CMOS_UPTIME_0 () { &NVRAM_OFFSET(0x30);}' unless defined(&COBT_CMOS_UPTIME_0);
    eval 'sub COBT_CMOS_UPTIME_1 () { &NVRAM_OFFSET(0x31);}' unless defined(&COBT_CMOS_UPTIME_1);
    eval 'sub COBT_CMOS_UPTIME_2 () { &NVRAM_OFFSET(0x32);}' unless defined(&COBT_CMOS_UPTIME_2);
    eval 'sub COBT_CMOS_UPTIME_3 () { &NVRAM_OFFSET(0x33);}' unless defined(&COBT_CMOS_UPTIME_3);
    eval 'sub COBT_CMOS_BOOTCOUNT_0 () { &NVRAM_OFFSET(0x38);}' unless defined(&COBT_CMOS_BOOTCOUNT_0);
    eval 'sub COBT_CMOS_BOOTCOUNT_1 () { &NVRAM_OFFSET(0x39);}' unless defined(&COBT_CMOS_BOOTCOUNT_1);
    eval 'sub COBT_CMOS_BOOTCOUNT_2 () { &NVRAM_OFFSET(0x3a);}' unless defined(&COBT_CMOS_BOOTCOUNT_2);
    eval 'sub COBT_CMOS_BOOTCOUNT_3 () { &NVRAM_OFFSET(0x3b);}' unless defined(&COBT_CMOS_BOOTCOUNT_3);
    eval 'sub COBT_CMOS_SYS_SERNUM_LEN () {13;}' unless defined(&COBT_CMOS_SYS_SERNUM_LEN);
    eval 'sub COBT_CMOS_SYS_SERNUM_0 () { &NVRAM_OFFSET(0x40);}' unless defined(&COBT_CMOS_SYS_SERNUM_0);
    eval 'sub COBT_CMOS_SYS_SERNUM_1 () { &NVRAM_OFFSET(0x41);}' unless defined(&COBT_CMOS_SYS_SERNUM_1);
    eval 'sub COBT_CMOS_SYS_SERNUM_2 () { &NVRAM_OFFSET(0x42);}' unless defined(&COBT_CMOS_SYS_SERNUM_2);
    eval 'sub COBT_CMOS_SYS_SERNUM_3 () { &NVRAM_OFFSET(0x43);}' unless defined(&COBT_CMOS_SYS_SERNUM_3);
    eval 'sub COBT_CMOS_SYS_SERNUM_4 () { &NVRAM_OFFSET(0x44);}' unless defined(&COBT_CMOS_SYS_SERNUM_4);
    eval 'sub COBT_CMOS_SYS_SERNUM_5 () { &NVRAM_OFFSET(0x45);}' unless defined(&COBT_CMOS_SYS_SERNUM_5);
    eval 'sub COBT_CMOS_SYS_SERNUM_6 () { &NVRAM_OFFSET(0x46);}' unless defined(&COBT_CMOS_SYS_SERNUM_6);
    eval 'sub COBT_CMOS_SYS_SERNUM_7 () { &NVRAM_OFFSET(0x47);}' unless defined(&COBT_CMOS_SYS_SERNUM_7);
    eval 'sub COBT_CMOS_SYS_SERNUM_8 () { &NVRAM_OFFSET(0x48);}' unless defined(&COBT_CMOS_SYS_SERNUM_8);
    eval 'sub COBT_CMOS_SYS_SERNUM_9 () { &NVRAM_OFFSET(0x49);}' unless defined(&COBT_CMOS_SYS_SERNUM_9);
    eval 'sub COBT_CMOS_SYS_SERNUM_10 () { &NVRAM_OFFSET(0x4a);}' unless defined(&COBT_CMOS_SYS_SERNUM_10);
    eval 'sub COBT_CMOS_SYS_SERNUM_11 () { &NVRAM_OFFSET(0x4b);}' unless defined(&COBT_CMOS_SYS_SERNUM_11);
    eval 'sub COBT_CMOS_SYS_SERNUM_12 () { &NVRAM_OFFSET(0x4c);}' unless defined(&COBT_CMOS_SYS_SERNUM_12);
    eval 'sub COBT_CMOS_SYS_SERNUM_CSUM () { &NVRAM_OFFSET(0x4f);}' unless defined(&COBT_CMOS_SYS_SERNUM_CSUM);
    eval 'sub COBT_CMOS_ROM_REV_MAJ () { &NVRAM_OFFSET(0x50);}' unless defined(&COBT_CMOS_ROM_REV_MAJ);
    eval 'sub COBT_CMOS_ROM_REV_MIN () { &NVRAM_OFFSET(0x51);}' unless defined(&COBT_CMOS_ROM_REV_MIN);
    eval 'sub COBT_CMOS_ROM_REV_REV () { &NVRAM_OFFSET(0x52);}' unless defined(&COBT_CMOS_ROM_REV_REV);
    eval 'sub COBT_CMOS_BTO_CODE_0 () { &NVRAM_OFFSET(0x53);}' unless defined(&COBT_CMOS_BTO_CODE_0);
    eval 'sub COBT_CMOS_BTO_CODE_1 () { &NVRAM_OFFSET(0x54);}' unless defined(&COBT_CMOS_BTO_CODE_1);
    eval 'sub COBT_CMOS_BTO_CODE_2 () { &NVRAM_OFFSET(0x55);}' unless defined(&COBT_CMOS_BTO_CODE_2);
    eval 'sub COBT_CMOS_BTO_CODE_3 () { &NVRAM_OFFSET(0x56);}' unless defined(&COBT_CMOS_BTO_CODE_3);
    eval 'sub COBT_CMOS_BTO_IP_CSUM () { &NVRAM_OFFSET(0x57);}' unless defined(&COBT_CMOS_BTO_IP_CSUM);
    eval 'sub COBT_CMOS_BTO_IP_0 () { &NVRAM_OFFSET(0x58);}' unless defined(&COBT_CMOS_BTO_IP_0);
    eval 'sub COBT_CMOS_BTO_IP_1 () { &NVRAM_OFFSET(0x59);}' unless defined(&COBT_CMOS_BTO_IP_1);
    eval 'sub COBT_CMOS_BTO_IP_2 () { &NVRAM_OFFSET(0x5a);}' unless defined(&COBT_CMOS_BTO_IP_2);
    eval 'sub COBT_CMOS_BTO_IP_3 () { &NVRAM_OFFSET(0x5b);}' unless defined(&COBT_CMOS_BTO_IP_3);
}
1;
