require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_IF_H)) {
    eval 'sub _LINUX_IF_H () {1;}' unless defined(&_LINUX_IF_H);
    require 'linux/types.ph';
    require 'linux/socket.ph';
    eval 'sub IFNAMSIZ () {16;}' unless defined(&IFNAMSIZ);
    require 'linux/hdlc/ioctl.ph';
    eval 'sub IFF_UP () {0x1;}' unless defined(&IFF_UP);
    eval 'sub IFF_BROADCAST () {0x2;}' unless defined(&IFF_BROADCAST);
    eval 'sub IFF_DEBUG () {0x4;}' unless defined(&IFF_DEBUG);
    eval 'sub IFF_LOOPBACK () {0x8;}' unless defined(&IFF_LOOPBACK);
    eval 'sub IFF_POINTOPOINT () {0x10;}' unless defined(&IFF_POINTOPOINT);
    eval 'sub IFF_NOTRAILERS () {0x20;}' unless defined(&IFF_NOTRAILERS);
    eval 'sub IFF_RUNNING () {0x40;}' unless defined(&IFF_RUNNING);
    eval 'sub IFF_NOARP () {0x80;}' unless defined(&IFF_NOARP);
    eval 'sub IFF_PROMISC () {0x100;}' unless defined(&IFF_PROMISC);
    eval 'sub IFF_ALLMULTI () {0x200;}' unless defined(&IFF_ALLMULTI);
    eval 'sub IFF_MASTER () {0x400;}' unless defined(&IFF_MASTER);
    eval 'sub IFF_SLAVE () {0x800;}' unless defined(&IFF_SLAVE);
    eval 'sub IFF_MULTICAST () {0x1000;}' unless defined(&IFF_MULTICAST);
    eval 'sub IFF_VOLATILE () {( &IFF_LOOPBACK| &IFF_POINTOPOINT| &IFF_BROADCAST| &IFF_MASTER| &IFF_SLAVE| &IFF_RUNNING);}' unless defined(&IFF_VOLATILE);
    eval 'sub IFF_PORTSEL () {0x2000;}' unless defined(&IFF_PORTSEL);
    eval 'sub IFF_AUTOMEDIA () {0x4000;}' unless defined(&IFF_AUTOMEDIA);
    eval 'sub IFF_DYNAMIC () {0x8000;}' unless defined(&IFF_DYNAMIC);
    eval 'sub IFF_802_1Q_VLAN () {0x1;}' unless defined(&IFF_802_1Q_VLAN);
    eval 'sub IF_GET_IFACE () {0x1;}' unless defined(&IF_GET_IFACE);
    eval 'sub IF_GET_PROTO () {0x2;}' unless defined(&IF_GET_PROTO);
    eval 'sub IF_IFACE_V35 () {0x1000;}' unless defined(&IF_IFACE_V35);
    eval 'sub IF_IFACE_V24 () {0x1001;}' unless defined(&IF_IFACE_V24);
    eval 'sub IF_IFACE_X21 () {0x1002;}' unless defined(&IF_IFACE_X21);
    eval 'sub IF_IFACE_T1 () {0x1003;}' unless defined(&IF_IFACE_T1);
    eval 'sub IF_IFACE_E1 () {0x1004;}' unless defined(&IF_IFACE_E1);
    eval 'sub IF_IFACE_SYNC_SERIAL () {0x1005;}' unless defined(&IF_IFACE_SYNC_SERIAL);
    eval 'sub IF_PROTO_HDLC () {0x2000;}' unless defined(&IF_PROTO_HDLC);
    eval 'sub IF_PROTO_PPP () {0x2001;}' unless defined(&IF_PROTO_PPP);
    eval 'sub IF_PROTO_CISCO () {0x2002;}' unless defined(&IF_PROTO_CISCO);
    eval 'sub IF_PROTO_FR () {0x2003;}' unless defined(&IF_PROTO_FR);
    eval 'sub IF_PROTO_FR_ADD_PVC () {0x2004;}' unless defined(&IF_PROTO_FR_ADD_PVC);
    eval 'sub IF_PROTO_FR_DEL_PVC () {0x2005;}' unless defined(&IF_PROTO_FR_DEL_PVC);
    eval 'sub IF_PROTO_X25 () {0x2006;}' unless defined(&IF_PROTO_X25);
    eval 'sub IF_PROTO_HDLC_ETH () {0x2007;}' unless defined(&IF_PROTO_HDLC_ETH);
    eval 'sub IF_PROTO_FR_ADD_ETH_PVC () {0x2008;}' unless defined(&IF_PROTO_FR_ADD_ETH_PVC);
    eval 'sub IF_PROTO_FR_DEL_ETH_PVC () {0x2009;}' unless defined(&IF_PROTO_FR_DEL_ETH_PVC);
    eval 'sub IF_PROTO_FR_PVC () {0x200a;}' unless defined(&IF_PROTO_FR_PVC);
    eval 'sub IF_PROTO_FR_ETH_PVC () {0x200b;}' unless defined(&IF_PROTO_FR_ETH_PVC);
    eval 'sub IFHWADDRLEN () {6;}' unless defined(&IFHWADDRLEN);
    eval 'sub ifr_name () { ($ifr_ifrn->{ifrn_name});}' unless defined(&ifr_name);
    eval 'sub ifr_hwaddr () { ($ifr_ifru->{ifru_hwaddr});}' unless defined(&ifr_hwaddr);
    eval 'sub ifr_addr () { ($ifr_ifru->{ifru_addr});}' unless defined(&ifr_addr);
    eval 'sub ifr_dstaddr () { ($ifr_ifru->{ifru_dstaddr});}' unless defined(&ifr_dstaddr);
    eval 'sub ifr_broadaddr () { ($ifr_ifru->{ifru_broadaddr});}' unless defined(&ifr_broadaddr);
    eval 'sub ifr_netmask () { ($ifr_ifru->{ifru_netmask});}' unless defined(&ifr_netmask);
    eval 'sub ifr_flags () { ($ifr_ifru->{ifru_flags});}' unless defined(&ifr_flags);
    eval 'sub ifr_metric () { ($ifr_ifru->{ifru_ivalue});}' unless defined(&ifr_metric);
    eval 'sub ifr_mtu () { ($ifr_ifru->{ifru_mtu});}' unless defined(&ifr_mtu);
    eval 'sub ifr_map () { ($ifr_ifru->{ifru_map});}' unless defined(&ifr_map);
    eval 'sub ifr_slave () { ($ifr_ifru->{ifru_slave});}' unless defined(&ifr_slave);
    eval 'sub ifr_data () { ($ifr_ifru->{ifru_data});}' unless defined(&ifr_data);
    eval 'sub ifr_ifindex () { ($ifr_ifru->{ifru_ivalue});}' unless defined(&ifr_ifindex);
    eval 'sub ifr_bandwidth () { ($ifr_ifru->{ifru_ivalue});}' unless defined(&ifr_bandwidth);
    eval 'sub ifr_qlen () { ($ifr_ifru->{ifru_ivalue});}' unless defined(&ifr_qlen);
    eval 'sub ifr_newname () { ($ifr_ifru->{ifru_newname});}' unless defined(&ifr_newname);
    eval 'sub ifr_settings () { ($ifr_ifru->{ifru_settings});}' unless defined(&ifr_settings);
    eval 'sub ifc_buf () { ($ifc_ifcu->{ifcu_buf});}' unless defined(&ifc_buf);
    eval 'sub ifc_req () { ($ifc_ifcu->{ifcu_req});}' unless defined(&ifc_req);
}
1;
