require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_LIST_H)) {
    eval 'sub _LINUX_LIST_H () {1;}' unless defined(&_LINUX_LIST_H);
    if(defined( &__KERNEL__) || defined( &_LVM_H_INCLUDE)) {
	require 'linux/prefetch.ph';
	eval 'sub LIST_HEAD_INIT {
	    local($name) = @_;
    	    eval q({ ($name), ($name) });
	}' unless defined(&LIST_HEAD_INIT);
	eval 'sub LIST_HEAD {
	    local($name) = @_;
    	    eval q(\'struct list_head\' $name =  &LIST_HEAD_INIT($name));
	}' unless defined(&LIST_HEAD);
	eval 'sub INIT_LIST_HEAD {
	    local($ptr) = @_;
    	    eval q( &do { ($ptr)-> &next = ($ptr); ($ptr)-> &prev = ($ptr); }  &while (0));
	}' unless defined(&INIT_LIST_HEAD);
	eval 'sub __list_splice {
	    local($list,$head) = @_;
    	    eval q({ \'struct list_head\' * &first =  ($list->{next}); \'struct list_head\' * &last =  ($list->{prev}); \'struct list_head\' * &at =  ($head->{next});  ($first->{prev}) = $head;  ($head->{next}) =  &first;  ($last->{next}) =  &at;  ($at->{prev}) =  &last; });
	}' unless defined(&__list_splice);
	eval 'sub list_entry {
	    local($ptr, $type, $member) = @_;
    	    eval q((($type *)(-((($type *)0)->$member))));
	}' unless defined(&list_entry);
	eval 'sub list_for_each {
	    local($pos, $head) = @_;
    	    eval q( &for ($pos = ($head)-> &next,  &prefetch( ($pos->{next})); $pos != ($head); $pos =  ($pos->{next}),  &prefetch( ($pos->{next}))));
	}' unless defined(&list_for_each);
	eval 'sub list_for_each_prev {
	    local($pos, $head) = @_;
    	    eval q( &for ($pos = ($head)-> &prev,  &prefetch( ($pos->{prev})); $pos != ($head); $pos =  ($pos->{prev}),  &prefetch( ($pos->{prev}))));
	}' unless defined(&list_for_each_prev);
	eval 'sub list_for_each_safe {
	    local($pos, $n, $head) = @_;
    	    eval q( &for ($pos = ($head)-> &next, $n =  ($pos->{next}); $pos != ($head); $pos = $n, $n =  ($pos->{next})));
	}' unless defined(&list_for_each_safe);
	eval 'sub list_for_each_entry {
	    local($pos, $head, $member) = @_;
    	    eval q( &for ($pos =  &list_entry(($head)-> &next,  &typeof(*$pos), $member),  &prefetch( ($pos->{member}->{next}));  ($pos->{member}) != ($head); $pos =  &list_entry( ($pos->{member}->{next}),  &typeof(*$pos), $member),  &prefetch( ($pos->{member}->{next}))));
	}' unless defined(&list_for_each_entry);
	eval 'sub list_for_each_entry_safe {
	    local($pos, $n, $head, $member) = @_;
    	    eval q( &for ($pos =  &list_entry(($head)-> &next,  &typeof(*$pos), $member), $n =  &list_entry( ($pos->{member}->{next}),  &typeof(*$pos), $member);  ($pos->{member}) != ($head); $pos = $n, $n =  &list_entry( ($n->{member}->{next}),  &typeof(*$n), $member)));
	}' unless defined(&list_for_each_entry_safe);
	eval 'sub list_for_each_entry_continue {
	    local($pos, $head, $member) = @_;
    	    eval q( &for ($pos =  &list_entry( ($pos->{member}->{next}),  &typeof(*$pos), $member),  &prefetch( ($pos->{member}->{next}));  ($pos->{member}) != ($head); $pos =  &list_entry( ($pos->{member}->{next}),  &typeof(*$pos), $member),  &prefetch( ($pos->{member}->{next}))));
	}' unless defined(&list_for_each_entry_continue);
    }
}
1;
