require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_LP_H)) {
    eval 'sub _LINUX_LP_H () {1;}' unless defined(&_LINUX_LP_H);
    eval 'sub LP_EXIST () {0x1;}' unless defined(&LP_EXIST);
    eval 'sub LP_SELEC () {0x2;}' unless defined(&LP_SELEC);
    eval 'sub LP_BUSY () {0x4;}' unless defined(&LP_BUSY);
    eval 'sub LP_BUSY_BIT_POS () {2;}' unless defined(&LP_BUSY_BIT_POS);
    eval 'sub LP_OFFL () {0x8;}' unless defined(&LP_OFFL);
    eval 'sub LP_NOPA () {0x10;}' unless defined(&LP_NOPA);
    eval 'sub LP_ERR () {0x20;}' unless defined(&LP_ERR);
    eval 'sub LP_ABORT () {0x40;}' unless defined(&LP_ABORT);
    eval 'sub LP_CAREFUL () {0x80;}' unless defined(&LP_CAREFUL);
    eval 'sub LP_ABORTOPEN () {0x100;}' unless defined(&LP_ABORTOPEN);
    eval 'sub LP_TRUST_IRQ_ () {0x200;}' unless defined(&LP_TRUST_IRQ_);
    eval 'sub LP_NO_REVERSE () {0x400;}' unless defined(&LP_NO_REVERSE);
    eval 'sub LP_DATA_AVAIL () {0x800;}' unless defined(&LP_DATA_AVAIL);
    eval 'sub LP_PBUSY () {0x80;}' unless defined(&LP_PBUSY);
    eval 'sub LP_PACK () {0x40;}' unless defined(&LP_PACK);
    eval 'sub LP_POUTPA () {0x20;}' unless defined(&LP_POUTPA);
    eval 'sub LP_PSELECD () {0x10;}' unless defined(&LP_PSELECD);
    eval 'sub LP_PERRORP () {0x8;}' unless defined(&LP_PERRORP);
    eval 'sub LP_INIT_CHAR () {1000;}' unless defined(&LP_INIT_CHAR);
    eval 'sub LP_INIT_WAIT () {1;}' unless defined(&LP_INIT_WAIT);
    eval 'sub LP_INIT_TIME () {2;}' unless defined(&LP_INIT_TIME);
    eval 'sub LPCHAR () {0x601;}' unless defined(&LPCHAR);
    eval 'sub LPTIME () {0x602;}' unless defined(&LPTIME);
    eval 'sub LPABORT () {0x604;}' unless defined(&LPABORT);
    eval 'sub LPSETIRQ () {0x605;}' unless defined(&LPSETIRQ);
    eval 'sub LPGETIRQ () {0x606;}' unless defined(&LPGETIRQ);
    eval 'sub LPWAIT () {0x608;}' unless defined(&LPWAIT);
    eval 'sub LPCAREFUL () {0x609;}' unless defined(&LPCAREFUL);
    eval 'sub LPABORTOPEN () {0x60a;}' unless defined(&LPABORTOPEN);
    eval 'sub LPGETSTATUS () {0x60b;}' unless defined(&LPGETSTATUS);
    eval 'sub LPRESET () {0x60c;}' unless defined(&LPRESET);
    if(defined(&LP_STATS)) {
	eval 'sub LPGETSTATS () {0x60d;}' unless defined(&LPGETSTATS);
    }
    eval 'sub LPGETFLAGS () {0x60e;}' unless defined(&LPGETFLAGS);
    eval 'sub LPSETTIMEOUT () {0x60f;}' unless defined(&LPSETTIMEOUT);
    eval 'sub LP_TIMEOUT_INTERRUPT () {(60*  &HZ);}' unless defined(&LP_TIMEOUT_INTERRUPT);
    eval 'sub LP_TIMEOUT_POLLED () {(10*  &HZ);}' unless defined(&LP_TIMEOUT_POLLED);
    if(defined(&__KERNEL__)) {
	eval 'sub LP_PARPORT_UNSPEC () {-4;}' unless defined(&LP_PARPORT_UNSPEC);
	eval 'sub LP_PARPORT_AUTO () {-3;}' unless defined(&LP_PARPORT_AUTO);
	eval 'sub LP_PARPORT_OFF () {-2;}' unless defined(&LP_PARPORT_OFF);
	eval 'sub LP_PARPORT_NONE () {-1;}' unless defined(&LP_PARPORT_NONE);
	eval 'sub LP_F {
	    local($minor) = @_;
    	    eval q( ($lp_table[&(minor)]->{flags}));
	}' unless defined(&LP_F);
	eval 'sub LP_CHAR {
	    local($minor) = @_;
    	    eval q( ($lp_table[&(minor)]->{chars}));
	}' unless defined(&LP_CHAR);
	eval 'sub LP_TIME {
	    local($minor) = @_;
    	    eval q( ($lp_table[&(minor)]->{time}));
	}' unless defined(&LP_TIME);
	eval 'sub LP_WAIT {
	    local($minor) = @_;
    	    eval q( ($lp_table[&(minor)]->{wait}));
	}' unless defined(&LP_WAIT);
	eval 'sub LP_IRQ {
	    local($minor) = @_;
    	    eval q( ($lp_table[&(minor)]->{dev}->{port}->{irq}));
	}' unless defined(&LP_IRQ);
	if(defined(&LP_STATS)) {
	    eval 'sub LP_STAT {
	        local($minor) = @_;
    		eval q( ($lp_table[&(minor)]->{stats}));
	    }' unless defined(&LP_STAT);
	}
	eval 'sub LP_BUFFER_SIZE () { &PAGE_SIZE;}' unless defined(&LP_BUFFER_SIZE);
	eval 'sub LP_BASE {
	    local($x) = @_;
    	    eval q( ($lp_table[&(x)]->{dev}->{port}->{base}));
	}' unless defined(&LP_BASE);
	if(defined(&LP_STATS)) {
	}
	if(defined(&LP_STATS)) {
	}
	eval 'sub LP_PINTEN () {0x10;}' unless defined(&LP_PINTEN);
	eval 'sub LP_PSELECP () {0x8;}' unless defined(&LP_PSELECP);
	eval 'sub LP_PINITP () {0x4;}' unless defined(&LP_PINITP);
	eval 'sub LP_PAUTOLF () {0x2;}' unless defined(&LP_PAUTOLF);
	eval 'sub LP_PSTROBE () {0x1;}' unless defined(&LP_PSTROBE);
	eval 'sub LP_DUMMY () {0x;}' unless defined(&LP_DUMMY);
	eval 'sub LP_DELAY () {50;}' unless defined(&LP_DELAY);
    }
}
1;
