require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_SYSV_FS_H)) {
    eval 'sub _LINUX_SYSV_FS_H () {1;}' unless defined(&_LINUX_SYSV_FS_H);
    if(defined(&__GNUC__)) {
	eval 'sub __packed2__ () { &__attribute__ (( &packed,  &aligned(2)));}' unless defined(&__packed2__);
    } else {
	die("I\ want\ gcc\!");
    }
    require 'linux/stat.ph';
    require 'linux/sched.ph';
    require 'linux/sysv_fs_sb.ph';
    if(defined(&__LITTLE_ENDIAN)) {
    } else {
	if(defined(&__BIG_ENDIAN)) {
	} else {
	    die("BYTESEX");
	}
    }
    eval 'sub SYSV_BADBL_INO () {1;}' unless defined(&SYSV_BADBL_INO);
    eval 'sub SYSV_ROOT_INO () {2;}' unless defined(&SYSV_ROOT_INO);
    eval 'sub XENIX_NICINOD () {100;}' unless defined(&XENIX_NICINOD);
    eval 'sub XENIX_NICFREE () {100;}' unless defined(&XENIX_NICFREE);
    eval 'sub SYSV_NICINOD () {100;}' unless defined(&SYSV_NICINOD);
    eval 'sub SYSV_NICFREE () {50;}' unless defined(&SYSV_NICFREE);
    eval 'sub V7_NICINOD () {100;}' unless defined(&V7_NICINOD);
    eval 'sub V7_NICFREE () {50;}' unless defined(&V7_NICFREE);
    eval 'sub COH_NICINOD () {100;}' unless defined(&COH_NICINOD);
    eval 'sub COH_NICFREE () {64;}' unless defined(&COH_NICFREE);
    eval("sub XENIX_LINK_MAX () { 126; }") unless defined(&XENIX_LINK_MAX);
    eval("sub SYSV_LINK_MAX () { 126; }") unless defined(&SYSV_LINK_MAX);
    eval("sub V7_LINK_MAX () { 126; }") unless defined(&V7_LINK_MAX);
    eval("sub COH_LINK_MAX () { 10000; }") unless defined(&COH_LINK_MAX);
    eval 'sub SYSV_NAMELEN () {14;}' unless defined(&SYSV_NAMELEN);
    eval 'sub SYSV_DIRSIZE () {$sizeof{\'struct sysv_dir_entry\'};}' unless defined(&SYSV_DIRSIZE);
    eval("sub FSTYPE_NONE () { 0; }") unless defined(&FSTYPE_NONE);
    eval("sub FSTYPE_XENIX () { 1; }") unless defined(&FSTYPE_XENIX);
    eval("sub FSTYPE_SYSV4 () { 2; }") unless defined(&FSTYPE_SYSV4);
    eval("sub FSTYPE_SYSV2 () { 3; }") unless defined(&FSTYPE_SYSV2);
    eval("sub FSTYPE_COH () { 4; }") unless defined(&FSTYPE_COH);
    eval("sub FSTYPE_V7 () { 5; }") unless defined(&FSTYPE_V7);
    eval("sub FSTYPE_AFS () { 6; }") unless defined(&FSTYPE_AFS);
    eval("sub FSTYPE_END () { 7; }") unless defined(&FSTYPE_END);
    eval 'sub SYSV_MAGIC_BASE () {0x12ff7b3;}' unless defined(&SYSV_MAGIC_BASE);
    eval 'sub XENIX_SUPER_MAGIC () {( &SYSV_MAGIC_BASE+ &FSTYPE_XENIX);}' unless defined(&XENIX_SUPER_MAGIC);
    eval 'sub SYSV4_SUPER_MAGIC () {( &SYSV_MAGIC_BASE+ &FSTYPE_SYSV4);}' unless defined(&SYSV4_SUPER_MAGIC);
    eval 'sub SYSV2_SUPER_MAGIC () {( &SYSV_MAGIC_BASE+ &FSTYPE_SYSV2);}' unless defined(&SYSV2_SUPER_MAGIC);
    eval 'sub COH_SUPER_MAGIC () {( &SYSV_MAGIC_BASE+ &FSTYPE_COH);}' unless defined(&COH_SUPER_MAGIC);
    if(defined(&__KERNEL__)) {
	eval("sub BYTESEX_LE () { 0; }") unless defined(&BYTESEX_LE);
	eval("sub BYTESEX_PDP () { 1; }") unless defined(&BYTESEX_PDP);
	eval("sub BYTESEX_BE () { 2; }") unless defined(&BYTESEX_BE);
	eval 'sub dirty_sb {
	    local($sb) = @_;
    	    eval q({  &mark_buffer_dirty( ($sb->{sv_bh1}));  &if ( ($sb->{sv_bh1}) !=  ($sb->{sv_bh2}))  &mark_buffer_dirty( ($sb->{sv_bh2}));  ($sb->{s_dirt}) = 1; });
	}' unless defined(&dirty_sb);
	eval 'sub fs32_to_cpu {
	    local($sb,$n) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_PDP)  &PDP_swab($n);  &else  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_LE)  &le32_to_cpu($n);  &else  &be32_to_cpu($n); });
	}' unless defined(&fs32_to_cpu);
	eval 'sub cpu_to_fs32 {
	    local($sb,$n) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_PDP)  &PDP_swab($n);  &else  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_LE)  &cpu_to_le32($n);  &else  &cpu_to_be32($n); });
	}' unless defined(&cpu_to_fs32);
	eval 'sub fs32_add {
	    local($sb,$n,$d) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_PDP) *$n =  &PDP_swab( &PDP_swab(*$n)+$d);  &else  &if ( ($sb->{sv_bytesex}) ==  &BYTESEX_LE) *$n =  &cpu_to_le32( &le32_to_cpu(*$n)+$d);  &else *$n =  &cpu_to_be32( &be32_to_cpu(*$n)+$d); });
	}' unless defined(&fs32_add);
	eval 'sub fs16_to_cpu {
	    local($sb,$n) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) !=  &BYTESEX_BE)  &le16_to_cpu($n);  &else  &be16_to_cpu($n); });
	}' unless defined(&fs16_to_cpu);
	eval 'sub cpu_to_fs16 {
	    local($sb,$n) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) !=  &BYTESEX_BE)  &cpu_to_le16($n);  &else  &cpu_to_be16($n); });
	}' unless defined(&cpu_to_fs16);
	eval 'sub fs16_add {
	    local($sb,$n,$d) = @_;
    	    eval q({  &if ( ($sb->{sv_bytesex}) !=  &BYTESEX_BE) *$n =  &cpu_to_le16( &le16_to_cpu(*$n)+$d);  &else *$n =  &cpu_to_be16( &be16_to_cpu(*$n)+$d); });
	}' unless defined(&fs16_add);
    }
}
1;
